---
title: Range
slug: Web/HTTP/Headers/Range
tags:
  - HTTP
  - HTTP Header
  - Range Requests
  - Reference
  - Request header
---
<p>{{HTTPSidebar}}</p>

<p>The <strong><code>Range</code></strong> HTTP request header indicates the part of a document that the server should return. Several parts can be requested with one <code>Range</code> header at once, and the server may send back these ranges in a multipart document. If the server sends back ranges, it uses the {{HTTPStatus("206")}}<code> Partial Content</code> for the response. If the ranges are invalid, the server returns the {{HTTPStatus("416")}}<code> Range Not Satisfiable</code> error. The server can also ignore the <code>Range</code> header and return the whole document with a {{HTTPStatus("200")}} status code.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Range: &lt;unit&gt;=&lt;range-start&gt;-
Range: &lt;unit&gt;=&lt;range-start&gt;-&lt;range-end&gt;
Range: &lt;unit&gt;=&lt;range-start&gt;-&lt;range-end&gt;, &lt;range-start&gt;-&lt;range-end&gt;
Range: &lt;unit&gt;=&lt;range-start&gt;-&lt;range-end&gt;, &lt;range-start&gt;-&lt;range-end&gt;, &lt;range-start&gt;-&lt;range-end&gt;
Range: &lt;unit&gt;=-&lt;suffix-length&gt;</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>&lt;unit&gt;</dt>
 <dd>The unit in which ranges are specified. This is usually <code>bytes</code>.</dd>
</dl>

<dl>
 <dt>&lt;range-start&gt;</dt>
 <dd>An integer in the given unit indicating the beginning of the request range.</dd>
 <dt>&lt;range-end&gt;</dt>
 <dd>An integer in the given unit indicating the end of the requested range. This value is optional and, if omitted, the end of the document is taken as the end of the range.</dd>
 <dt>&lt;suffix-length&gt;</dt>
 <dd>An integer in the given unit indicating the number of units at the end of the file to return.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Requesting three ranges from the file.</p>

<pre class="notranslate">Range: bytes=200-1000, 2000-6576, 19000-
</pre>

<p>Requesting the first 500 and last 500 bytes of the file. The request may be rejected by the server if the ranges overlap.</p>

<pre class="notranslate">Range: bytes=0-499, -500
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7233", "Range", "3.1")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Range Requests</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Range")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("If-Range")}}</li>
 <li>{{HTTPHeader("Content-Range")}}</li>
 <li>{{HTTPHeader("Content-Type")}}</li>
 <li>{{HTTPStatus("206")}}<code> Partial Content</code></li>
 <li>{{HTTPStatus("416")}}<code> Range Not Satisfiable</code></li>
</ul>
